"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = initialisePlugin;

function safeRequire(name) {
  try {
    require.resolve(name);
  } catch (e) {
    return null;
  }

  try {
    return require(name);
  } catch (e) {
    throw new Error(`Couldn't initialise "${name}".\n${e.stack}`);
  }
}

function initialisePlugin(name, type, target = 'default') {
  if (name[0] === '@') {
    const service = safeRequire(name);
    return service[target];
  }

  const scopedPlugin = safeRequire(`@wdio/${name.toLowerCase()}-${type}`);

  if (scopedPlugin) {
    return scopedPlugin[target];
  }

  const plugin = safeRequire(`wdio-${name.toLowerCase()}-${type}`);

  if (plugin) {
    return plugin[target];
  }

  throw new Error(`Couldn't find plugin "${name}" ${type}, neither as wdio scoped package ` + `"@wdio/${name.toLowerCase()}-${type}" nor as community package ` + `"wdio-${name.toLowerCase()}-${type}". Please make sure you have it installed!`);
}